/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.pricecomparer.model.avro;

import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.SchemaStore;
import org.apache.avro.specific.SpecificData;

@org.apache.avro.specific.AvroGenerated
public class ProductTypeWrapper extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -9108787772531114502L;


  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"ProductTypeWrapper\",\"namespace\":\"com.pricecomparer.model.avro\",\"fields\":[{\"name\":\"productType\",\"type\":[\"null\",{\"type\":\"enum\",\"name\":\"ProductType\",\"symbols\":[\"APTEKA_GEMINI\"]}]}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static final SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<ProductTypeWrapper> ENCODER =
      new BinaryMessageEncoder<>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<ProductTypeWrapper> DECODER =
      new BinaryMessageDecoder<>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<ProductTypeWrapper> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<ProductTypeWrapper> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<ProductTypeWrapper> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this ProductTypeWrapper to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a ProductTypeWrapper from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a ProductTypeWrapper instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static ProductTypeWrapper fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  private ProductType productType;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public ProductTypeWrapper() {}

  /**
   * All-args constructor.
   * @param productType The new value for productType
   */
  public ProductTypeWrapper(ProductType productType) {
    this.productType = productType;
  }

  @Override
  public SpecificData getSpecificData() { return MODEL$; }

  @Override
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }

  // Used by DatumWriter.  Applications should not call.
  @Override
  public Object get(int field$) {
    switch (field$) {
    case 0: return productType;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  // Used by DatumReader.  Applications should not call.
  @Override
  @SuppressWarnings(value="unchecked")
  public void put(int field$, Object value$) {
    switch (field$) {
    case 0: productType = (ProductType)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'productType' field.
   * @return The value of the 'productType' field.
   */
  public ProductType getProductType() {
    return productType;
  }


  /**
   * Sets the value of the 'productType' field.
   * @param value the value to set.
   */
  public void setProductType(ProductType value) {
    this.productType = value;
  }

  /**
   * Creates a new ProductTypeWrapper RecordBuilder.
   * @return A new ProductTypeWrapper RecordBuilder
   */
  public static Builder newBuilder() {
    return new Builder();
  }

  /**
   * Creates a new ProductTypeWrapper RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new ProductTypeWrapper RecordBuilder
   */
  public static Builder newBuilder(Builder other) {
    if (other == null) {
      return new Builder();
    } else {
      return new Builder(other);
    }
  }

  /**
   * Creates a new ProductTypeWrapper RecordBuilder by copying an existing ProductTypeWrapper instance.
   * @param other The existing instance to copy.
   * @return A new ProductTypeWrapper RecordBuilder
   */
  public static Builder newBuilder(ProductTypeWrapper other) {
    if (other == null) {
      return new Builder();
    } else {
      return new Builder(other);
    }
  }

  /**
   * RecordBuilder for ProductTypeWrapper instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<ProductTypeWrapper>
    implements org.apache.avro.data.RecordBuilder<ProductTypeWrapper> {

    private ProductType productType;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$, MODEL$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.productType)) {
        this.productType = data().deepCopy(fields()[0].schema(), other.productType);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
    }

    /**
     * Creates a Builder by copying an existing ProductTypeWrapper instance
     * @param other The existing instance to copy.
     */
    private Builder(ProductTypeWrapper other) {
      super(SCHEMA$, MODEL$);
      if (isValidValue(fields()[0], other.productType)) {
        this.productType = data().deepCopy(fields()[0].schema(), other.productType);
        fieldSetFlags()[0] = true;
      }
    }

    /**
      * Gets the value of the 'productType' field.
      * @return The value.
      */
    public ProductType getProductType() {
      return productType;
    }


    /**
      * Sets the value of the 'productType' field.
      * @param value The value of 'productType'.
      * @return This builder.
      */
    public Builder setProductType(ProductType value) {
      validate(fields()[0], value);
      this.productType = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'productType' field has been set.
      * @return True if the 'productType' field has been set, false otherwise.
      */
    public boolean hasProductType() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'productType' field.
      * @return This builder.
      */
    public Builder clearProductType() {
      productType = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public ProductTypeWrapper build() {
      try {
        ProductTypeWrapper record = new ProductTypeWrapper();
        record.productType = fieldSetFlags()[0] ? this.productType : (ProductType) defaultValue(fields()[0]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<ProductTypeWrapper>
    WRITER$ = (org.apache.avro.io.DatumWriter<ProductTypeWrapper>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<ProductTypeWrapper>
    READER$ = (org.apache.avro.io.DatumReader<ProductTypeWrapper>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

  @Override protected boolean hasCustomCoders() { return true; }

  @Override public void customEncode(org.apache.avro.io.Encoder out)
    throws java.io.IOException
  {
    if (this.productType == null) {
      out.writeIndex(0);
      out.writeNull();
    } else {
      out.writeIndex(1);
      out.writeEnum(this.productType.ordinal());
    }

  }

  @Override public void customDecode(org.apache.avro.io.ResolvingDecoder in)
    throws java.io.IOException
  {
    org.apache.avro.Schema.Field[] fieldOrder = in.readFieldOrderIfDiff();
    if (fieldOrder == null) {
      if (in.readIndex() != 1) {
        in.readNull();
        this.productType = null;
      } else {
        this.productType = ProductType.values()[in.readEnum()];
      }

    } else {
      for (int i = 0; i < 1; i++) {
        switch (fieldOrder[i].pos()) {
        case 0:
          if (in.readIndex() != 1) {
            in.readNull();
            this.productType = null;
          } else {
            this.productType = ProductType.values()[in.readEnum()];
          }
          break;

        default:
          throw new java.io.IOException("Corrupt ResolvingDecoder.");
        }
      }
    }
  }
}










